#!/usr/bin/perl
# Show a form for creating or editing an image storage location

require './server-manager-lib.pl';
&can_action_error(undef, "global");
&ReadParse();
@storages = &list_storages();
if ($in{'new'}) {
	&ui_print_header(undef, $text{'storage_title1'}, "");
	$storage = { dest => '/tmp' };
	}
else {
	&ui_print_header(undef, $text{'storage_title2'}, "");
	($storage) = grep { $_->{'id'} eq $in{'id'} } @storages;
	$storage || &error($text{'storage_egone'});
	}

print &ui_form_start("save_storage.cgi", "post");
print &ui_hidden("new", $in{'new'});
print &ui_hidden("id", $in{'id'});
print &ui_table_start($text{'storage_header'}, "width=100%", 2);

# Storage location description
print &ui_table_row($text{'storage_desc'},
	&ui_textbox("desc", $storage->{'desc'}, 60));

# Server and path
$dest = &parse_backup_destination($storage->{'dest'});
@servers = &list_managed_servers_sorted(0);
print &ui_table_row($text{'storage_dest'},
    &ui_radio_table("mode", $dest->{'mode'},
	[ [ 0, $text{'backups_mode0'},
	       &ui_textbox("masterdir", $dest->{'mode'} == 0 ?
						$dest->{'path'} : "", 40) ],
	  [ 1, $text{'backups_mode1'},
	       &ui_textbox("hostdir", $dest->{'mode'} == 1 ?
						$dest->{'path'} : "", 40) ],
	  [ 2, $text{'backups_mode2'},
	       &ui_select("vm2", $dest->{'id'},
			  [ map { [ $_->{'id'}, $_->{'host'} ] } @servers ]).
	       " ".
	       &ui_textbox("vm2dir", $dest->{'mode'} == 2 ?
						$dest->{'path'} : "", 40) ],
	]));

# For location groups
@locs = &list_locations();
if (@locs) {
	@forlocs = split(/\s+/, $storage->{'location'});
	print &ui_table_row($text{'storage_location'},
		&ui_radio("location_def", $storage->{'location'} ? 0 : 1,
			  [ [ 1, $text{'storage_location1'} ],
			    [ 0, $text{'storage_location0'} ] ])."<br>\n".
		&ui_select("location", \@forlocs,
			   [ map { [ $_->{'id'}, $_->{'desc'} ] } @locs ],
			   scalar(@locs)+1, 1, 1));
	}

# Current size
if (!$in{'new'}) {
	print &ui_table_row($text{'storage_size'},
		&nice_size($storage->{'size'}));
	}

print &ui_table_end();

print &ui_form_end(
    $in{'new'} ? [ [ undef, $text{'create'} ] ]
	       : [ [ undef, $text{'save'} ],
		   [ 'delete', $text{'delete'} ] ]); 

&ui_print_footer("list_storages.cgi", $text{'storages_return'});

