#!/usr/bin/perl
# Create, update or delete an image storage location

require './server-manager-lib.pl';
&error_setup($text{'storage_err'});
&error_if_cloudmin_replica();
&can_action_error(undef, "global");
&ReadParse();
@storages = &list_storages();

if (!$in{'new'}) {	
	# Get the storage
	$storage = &get_storage($in{'id'});
	$storage || &error($text{'storage_egone'});
	}
else {
	$storage = { };
	}

if ($in{'delete'}) {
	# Delete this location
	&error_setup($text{'storage_err2'});
	@storages > 1 || &error($text{'storage_enoneleft'});
	&delete_storage($storage);
	&webmin_log("delete", "storage", $storage->{'id'},
		    { 'desc' => $storage->{'desc'} });
	}
else {
	# Validate and store inputs
	$in{'desc'} =~ /\S/ || &error($text{'storage_edesc'});
	$storage->{'desc'} = $in{'desc'};

	# Parse directory
	my $mode = $in{'mode'};
	my $dest = { 'mode' => $mode };
	if ($mode == 0) {
		$dest->{'path'} = $in{'masterdir'};
		$dest->{'path'} =~ /^\/\S+/ || &error($text{'backups_emode0'});
		}
	elsif ($mode == 1) {
		$dest->{'path'} = $in{'hostdir'};
		$dest->{'path'} =~ /^\/\S+/ || &error($text{'backups_emode1'});
		}
	elsif ($mode == 2) {
		$dest->{'path'} = $in{'vm2dir'};
		$dest->{'id'} = $in{'vm2'};
		$dest->{'path'} =~ /^\/\S+/ || &error($text{'backups_emode2'});
		}
	$newdest = &join_backup_destination($dest);
	if ($in{'new'} || $storage->{'dest'} ne $newdest) {
		($clash) = grep { $_->{'dest'} eq $newdest } @storages;
		$clash && &error(&text('storage_eclash', $clash->{'desc'}));
		}
	$storage->{'dest'} = $newdest;

	# Save groups
	@locs = &list_locations();
	if (@locs) {
		$storage->{'location'} = $in{'location_def'} ? undef :
			join(' ', split(/\s+/, $in{'location'}));
		}

	# Save and apply
	&save_storage($storage);
	&webmin_log($in{'new'} ? 'create' : 'modify', "storage",
		    $storage->{'id'},
		    { 'desc' => $storage->{'desc'} });
	}

&redirect("list_storages.cgi");

